SystemOrganization addCategory: 'OrbeonRestServices'!

!WALinkedAssignmentManager methodsFor: '*orbeonRestServices' stamp: 'BrunoBB 11/08/2014 09:23'!
linkToOrbeonFormFor: anOrbeonFormTransition
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: anOrbeonFormTransition 
					for: self session user.

	^self requestContext redirectTo: (self getUrlFor: anOrbeonFormTransition with: uuid).! !

WARestfulHandler subclass: #WAOrbeonServiceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonRestServices'!

!WAOrbeonServiceHandler class methodsFor: 'other' stamp: 'BrunoBB 05/01/2014 14:24'!
initialize

   WAAdmin register: self at: 'orbeon-api'! !

!WAOrbeonServiceHandler class methodsFor: 'other' stamp: 'BrunoBB 06/16/2014 15:27'!
register

	WAAdmin register: self at: 'orbeon-api'! !

!WAOrbeonServiceHandler class methodsFor: 'other' stamp: 'BrunoBB 05/01/2014 14:55'!
uninitialize

   WAAdmin unregister: 'orbeon-api'! !

!WAOrbeonServiceHandler class methodsFor: 'other' stamp: 'BrunoBB 06/16/2014 15:27'!
unregister

	WAAdmin unregister: 'orbeon-api'! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 06/16/2014 12:01'!
answerXMLErrorWith: uuidToken

"	^'<result>
		<error>', uuidToken,'</error>
	</result>'
"


	^'<result>
		<formid></formid>
		<username></username>
	</result>'! !

!WAOrbeonServiceHandler methodsFor: 'other' stamp: 'BrunoBB 06/16/2014 15:27'!
autorizeRequest

	self requestContext request headerAt: 'auth' ifAbsent: [^false].

	^true! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 12/22/2014 14:13'!
generateEmbeddedUrlFor: anOrbeonFormTransition user: user s: seasideS k: seasideK params: postParamsArray
	"http://orbeonIP:port/orbeon/fr/[app]/[formulario]/edit/[formId]"
	| uuid |

	uuid := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: anOrbeonFormTransition 
					for: user.

		^OrbeonServerConfiguration default orbeonIP,
			'/orbeon/fr/', 
			(postParamsArray at: 4), '/', 
			(postParamsArray at: 5), '/edit/', 
			(postParamsArray at: 1),'?token=', uuid, '&s=', seasideS,'&k=', seasideK, '&oop=', anOrbeonFormTransition asOop printString! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 03/07/2015 07:20'!
generateHtmlExceptionFor: anException params: anArray

	^'<!!DOCTYPE html>
<html>
<body>

<h1>Exception</h1>
<h2>Application: ', anArray fourth,'</h2>
<h2>Form Name: ', anArray fifth,'</h2>
<h2>Form ID: ', anArray first,'</h2>
<h2>Language: ', anArray second,'</h2>
<h2>Valid: ', anArray third,'</h2>

<p>', anException description,'</p>
<p>', (GsProcess stackReportToLevel: 20),'</p>

</body>
</html>'! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 07/16/2015 12:15'!
generateHtmlFor: anOrbeonFormTranstion xml: xmlString params: anArray
	"Generate an HTML that does a redirect to Seaside app with _s and _k parameters.
	In Orbeon the send() command is configured with replace='all' "
	| doc seasideS seasideK url user |

	doc := XMLDOMParser parse: xmlString.
	seasideS := (doc findElementNamed: 's') stringNodes last string.
	seasideK := (doc findElementNamed: 'k') stringNodes last string.
	user := OrbeonFormUser getUserNamed: (doc findElementNamed: 'username') stringNodes last string.
	url := user orbeonWebIsLinked
		ifTrue: [self generateLinkedUrlFor_S: seasideS andK: seasideK]
		ifFalse: [self generateEmbeddedUrlFor: anOrbeonFormTranstion user: user s: seasideS k: seasideK params: anArray].

	^user orbeonWebIsLinked 
		ifTrue: [self generateHtmlForRedirectTo: url]
		ifFalse: [self generateHtmlIframeParentRefresh: url]! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 11/08/2014 10:09'!
generateHtmlForRedirectTo: url

	^'<!!DOCTYPE HTML>
<meta charset="UTF-8">
<meta http-equiv="refresh" content="1; url=', url,'">
 <script>
  top.location.href = "', url,'"
</script>
 <title>Page Redirection</title>
 If you are not redirected automatically, follow the <a href=''', url,'''>link to example</a>'! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 11/08/2014 10:43'!
generateHtmlIframeParentRefresh: url

	^'<!!DOCTYPE HTML>
<meta charset="UTF-8">
<meta http-equiv="refresh" content="1; url=', url,'">
 <script>
  window.location.href = "', url,'"
</script>
 <title>Page Redirection</title>
 If you are not redirected automatically, follow the <a href=''', url,'''>link to example</a>'! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 12/22/2014 14:13'!
generateLinkedUrlFor_S: seasideS andK: seasideK

		^OrbeonServerConfiguration default gemstoneIP,'/orbeonProcess?_s=', seasideS, '&_k=', seasideK! !

!WAOrbeonServiceHandler methodsFor: 'services' stamp: 'BrunoBB 06/16/2014 15:27'!
getApplication: appName ifNone: aBlock
	| app |

	app := OrbeonApplication applicationNamed: appName.
	app isNil ifTrue: [^aBlock value].

	^app! !

!WAOrbeonServiceHandler methodsFor: 'definition' stamp: 'BrunoBB 06/16/2014 15:27'!
getFieldsOf: appName form: formName
	<get>
    <path: '/fieldsOf?app={1}&form={2}'> 
	<produces: 'text/xml'>

	| app formDef |

	self autorizeRequest ifFalse: [^self returnXmlError: 'Autorization Error'].
	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].
	formDef := self getFormDefinition: formName in: app ifNone: [^self returnXmlError: 'No such Form'].

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'fieldsDescription' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'form-name' with: formName.
			xml tag: 'fields' with: [
				formDef fieldNames do: [:eachName |  xml tag: 'field' with: eachName.]]]].! !

!WAOrbeonServiceHandler methodsFor: 'definition' stamp: 'BrunoBB 06/16/2014 15:27'!
getFieldTypesOf: formName in: appName
	<get>
    <path: '/fieldTypesOf?form={1}&app={2}'> 
	<produces: 'text/xml'>

	| app formDef |

	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].
	formDef := self getFormDefinition: formName in: app ifNone: [^self returnXmlError: 'No such Form'].

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'types' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'form-name' with: formName.
			xml tag: 'field-type' with: [
				formDef fieldDefinitionDo: [:eachField |  xml tag: 'field-type-definition' with: [
																		xml tag: 'field-name' with: eachField name.
																		xml tag: 'type' with: eachField type]]]]].! !

!WAOrbeonServiceHandler methodsFor: 'instance' stamp: 'BrunoBB 06/16/2014 15:27'!
getFieldValuesOf: formName in: appName id: formId fieldCollection: fieldCollection
	<get>
    <path: '/fieldValuesOf?form={1}&app={2}&id={3}&col={4}'> 
	<produces: 'text/xml'>
"falta implementar"
	| app formDef instance |

	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].
	formDef := self getFormDefinition: formName in: app ifNone: [^self returnXmlError: 'No such Form'].

	instance := formDef getInstanceWithId: formId ifNone: [^self returnXmlError: 'No such Form Instance'].

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'fieldValues' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'form-name' with: formName.
			xml tag: 'form-id' with: formId.
			xml tag: 'field-values' with: [
				(fieldCollection subStrings: ',') do: [:fieldName |  xml tag: 'fields' with: [
																						 xml tag: 'field' with: fieldName.
																						 xml tag: 'value' with: (instance valueAt: fieldName).]]]]].! !

!WAOrbeonServiceHandler methodsFor: 'services' stamp: 'BrunoBB 06/16/2014 15:27'!
getFormDefinition: formName in: anOrbeonApplication ifNone: aBlock

	^anOrbeonApplication definitionNamed: formName ifNone: aBlock! !

!WAOrbeonServiceHandler methodsFor: 'definition' stamp: 'BrunoBB 11/19/2014 12:36'!
getFormDefinitionsOf: appName
	<get>
    <path: '/formDefinitionsOf?app={1}'> 
	<produces: 'text/xml'>

	| app formDef definitionsNames |

	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].

	definitionsNames := app getLastDefinitions collect: [:each | each form].

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'formDefinitions' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'definition-names' with: [
				definitionsNames do: [:eachName |  xml tag: 'definition-name' with: eachName.]]]].! !

!WAOrbeonServiceHandler methodsFor: 'definition' stamp: 'BrunoBB 06/16/2014 15:27'!
getNumberOf: formName in: appName
	<get>
    <path: '/numberOf?form={1}&app={2}'> 
	<produces: 'text/xml'>

	| app formDef |

	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].
	formDef := self getFormDefinition: formName in: app ifNone: [^self returnXmlError: 'No such Form'].

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'number-of-forms' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'form-name' with: formName.
			xml tag: 'number' with: formDef numberOfInstances]].! !

!WAOrbeonServiceHandler methodsFor: 'instance' stamp: 'BrunoBB 06/16/2014 15:27'!
getNumberOf: formName in: appName field: fieldName value: argValue
	<get>
    <path: '/fieldValuesOf?form={1}&app={2}&field={3}&value={4}'> 
	<produces: 'text/xml'>
"falta implementar"
	| app formDef instances |

	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].
	formDef := self getFormDefinition: formName in: app ifNone: [^self returnXmlError: 'No such Form'].

	instances := formDef getInstancesSatisfying: [:each | each value = argValue] in: fieldName.

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'forms-satisfying' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'form-name' with: formName.
			xml tag: 'field-name' with: fieldName.
			xml tag: 'arg-value' with: argValue.
			xml tag: 'field-values' with: [
				instances do: [:form |  xml tag: 'ids' with: [
																 xml tag: 'id' with: form id.]]]]].! !

!WAOrbeonServiceHandler methodsFor: 'definition' stamp: 'BrunoBB 06/16/2014 15:27'!
geTotaltNumberOfFormsIn: appName
	<get>
    <path: '/totalNumberOfFormsIn?app={1}'> 
	<produces: 'text/xml'>

	| app |

	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'number-of-forms' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'total-number' with: app numberOfInstances]].! !

!WAOrbeonServiceHandler methodsFor: 'definition' stamp: 'BrunoBB 06/16/2014 15:27'!
getSearchFieldOf: formName in: appName
	<get>
    <path: '/searchFieldsOf?form={1}&app={2}'> 
	<produces: 'text/xml'>

	| app formDef summaryFields |

	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].
	formDef := self getFormDefinition: formName in: app ifNone: [^self returnXmlError: 'No such Form'].

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'search' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'form-name' with: formName.
			xml tag: 'search-fields' with: [
				(formDef selectFieldDefinition: [:each | each isSearch]) asOrderedCollection do: [:eachField |  xml tag: 'field' with: eachField name.]]]].! !

!WAOrbeonServiceHandler methodsFor: 'definition' stamp: 'BrunoBB 06/16/2014 15:27'!
getSummaryFieldOf: formName in: appName
	<get>
    <path: '/summaryFieldsOf?form={1}&app={2}'> 
	<produces: 'text/xml'>

	| app formDef summaryFields |

	app := self getApplication: appName ifNone: [^self returnXmlError: 'No such Application'].
	formDef := self getFormDefinition: formName in: app ifNone: [^self returnXmlError: 'No such Form'].

  ^ WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'summary' with: [
			xml tag: 'application-name' with: appName.
			xml tag: 'form-name' with: formName.
			xml tag: 'summary-fields' with: [
				(formDef selectFieldDefinition: [:each | each isSummary]) asOrderedCollection do: [:eachField |  xml tag: 'field' with: eachField name.]]]].! !

!WAOrbeonServiceHandler methodsFor: 'other' stamp: 'BrunoBB 05/16/2014 11:48'!
list
	<get>
	<path: '/'>
	self requestContext respond: [ :response |
		response contentType: 'text/plain'.
			response
				nextPutAll: 'TEST';
				nextPutAll: String crlf ]! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 07/26/2014 06:00'!
newOrbeonDefinition: id language: lan valid: valid app: app form: form
	"POST service to process an Orben XML form with id <id> language <lan> for the OrbeonApplication named <app> for the OrbeonForm named <form>.
	1- Register the XML in the system and update Domain Objects.
	2- With data context inside the XML (inside the post) generate an url link to the previous page but with domain data updated.
	3- The POST service answer a HTML code with a redirect (with javascript) to the url build in step 2."
	<post>
	<path: '/processdefinition?document={1}&language={2}&valid={3}&app={4}&form={5}'>
	<produces: 'xml'>

	OrbeonFormPostRegistry default addToHistory: (self requestContext request bodyDecodeUsing: 'utf-8').

	^'<result>ok</result>'! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 04/05/2015 15:33'!
newOrbeonFormId: id language: lan valid: valid app: app form: form
	"POST service to process an Orben XML form with id <id> language <lan> for the OrbeonApplication named <app> for the OrbeonForm named <form>.
	1- Register the XML in the system and update Domain Objects.
	2- With data context inside the XML (inside the post) generate an url link to the previous page but with domain data updated.
	3- The POST service answer a HTML code with a redirect (with javascript) to the url build in step 2."
	| serviceResult |
	<post>
	<path: '/processform?document={1}&language={2}&valid={3}&app={4}&form={5}'>
	<produces: 'text/html'>

	"register and process the XML in the Domain Model"
	serviceResult := OrbeonFormPostRegistry default 
					registerXML: (self requestContext request bodyDecodeUsing: 'utf-8') app: app form: form id: id language: lan valid: valid. 

	serviceResult hasException ifTrue: [^self generateHtmlExceptionFor: serviceResult exception params: (Array with: id with: lan with: valid with: app with: form)].
	 "answer an HTML code with a redirect to the previous (but updated) page "
	 ^self generateHtmlFor: serviceResult objectResult
			xml: (OrbeonFormPostRegistry default getForm: (app,'.',form,'.',id)) 
			params: (Array with: id with: lan with: valid with: app with: form)! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 07/05/2015 16:02'!
newProcessFromOrbeonFormId: id language: lan valid: valid app: app form: form
	"POST service to process an Orben XML form with id <id> language <lan> for the OrbeonApplication named <app> for the OrbeonForm named <form>.
	1- Register the XML in the system and update Domain Objects.
	2- Get the Process Definition for the Orbeon Instance Form.
	3- Create the Process based on the definition and finish the first transition of the Process -the annonimous user has already sent the finished form-"
	<post>
	<path: '/createprocess?document={1}&language={2}&valid={3}&app={4}&form={5}'>
	<produces: 'text/xml'>
	| formInstance procDefinition newProcess transition |

	formInstance := OrbeonFormPostRegistry default 
			registerAnnonimousXML: (self requestContext request bodyDecodeUsing: 'utf-8') app: app form: form id: id. "register and process the XML in the Domain Model"
	procDefinition := OrbeonFormProcessDefinition getProcesssDefinitionFor: formInstance app form: formInstance form.
	newProcess := procDefinition createProcess: nil "user annonimous".
	newProcess startProcessRoots. "it create the firsts transitions of the process"
	newProcess hasRunningTransitions ifFalse: [newProcess removeFromDefinitionDictionary. ^'<result>ERR</result>'].
	transition := newProcess selectRunningTransitionFor: formInstance. "parametro"
	transition orbeonFormInstance: formInstance.
	transition finalize.
	transition generateNextRunningTransitions.

	^'<result>ok</result>'! !

!WAOrbeonServiceHandler methodsFor: 'orbeon' stamp: 'BrunoBB 09/16/2014 18:25'!
orbeonSecurityToken: uuidToken
	"The security GET service take an uuid as a parameter <uuidToken> and:
	1- Check via lookup if it has associated XML. 
	2- If it so then answer the XML string associate with the token. 
	3- If not then answer a XML string with the same structure as 2 but with empty nodes values."
	<get>
    <path: '/securityToken?token={1}'> 
	<produces: 'text/xml'>
	| serviceRegistry serviceValue |

	serviceRegistry := OrbeonTempServiceRegistry default.  "asigno a la variable <serviceRegistry> el objeto adminitrados de los servicios"
	serviceValue := serviceRegistry getSecureValueForToken: uuidToken. "el administrador de servicios con la clave <uuidToken> obtiene el XML asociado -tipo hash table-"
	serviceValue ifNil: [^self answerXMLErrorWith: uuidToken]. "si no existe ese <uuidToken> entonces devuelve un XML con la estructura correcta pero vacia"

	serviceRegistry unregister: uuidToken. "elimina la entrada <uuidToken> - nadie podra llamar al servicio nuevamente -por seguridad-"
	
  ^serviceValue "devuelve el XML a Orbeon con los datos de los campos obligatorios"! !

!WAOrbeonServiceHandler methodsFor: 'other' stamp: 'BrunoBB 06/16/2014 15:27'!
returnError: ex

	DebuggerLogEntry createContinuationLabeled: 'Restful API Error: ', ex description.
	^'API Error: ', ex description! !

!WAOrbeonServiceHandler methodsFor: 'other' stamp: 'BrunoBB 06/16/2014 15:27'!
returnXmlError: errorString

	^WAXmlCanvas builder 
      documentClass: WAXmlDocument;
      render: [ :xml |
		xml tag: 'error' with: errorString].! !

Object subclass: #OrbeonFormPostRegistry
	instanceVariableNames: 'forms formsHistory requestCache'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonRestServices'!

!OrbeonFormPostRegistry class methodsFor: 'other' stamp: 'BrunoBB 06/11/2014 06:37'!
default

	Default ifNil: [ Default := super new initialize].

	^Default! !

!OrbeonFormPostRegistry class methodsFor: 'other' stamp: 'BrunoBB 12/31/2014 15:31'!
default: anObject

	Default := anObject.

	^Default! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 09/05/2014 05:55'!
addRequest: aRequest

	^requestCache add: aRequest! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/30/2014 19:25'!
addToHistory: anObject

	formsHistory add: anObject! !

!OrbeonFormPostRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 06/11/2014 06:36'!
forms

   "Return the value of the instance variable 'forms'."
   ^forms! !

!OrbeonFormPostRegistry methodsFor: 'Updating' stamp: 'BrunoBB 06/11/2014 06:36'!
forms: newValue

   "Modify the value of the instance variable 'forms'."
   forms := newValue! !

!OrbeonFormPostRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 06/11/2014 06:36'!
formsHistory

   "Return the value of the instance variable 'formsHistory'."
   ^formsHistory! !

!OrbeonFormPostRegistry methodsFor: 'Updating' stamp: 'BrunoBB 06/11/2014 06:36'!
formsHistory: newValue

   "Modify the value of the instance variable 'formsHistory'."
   formsHistory := newValue! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/30/2014 19:37'!
getForm: id

	^forms at: id ifAbsent: ['']! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 09/05/2014 05:50'!
initialize

	super initialize.

	forms := Dictionary new.
	formsHistory := OrderedCollection new.
	requestCache := OrderedCollection new.! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/23/2015 11:27'!
registerAnnonimousXML: xmlString app: app form: form id: id
	"The receiver register a XML <xmlString> of the OrbeonApplication named <app> of the OrbeonFormDefinition named <form> with an Orbeon database ID <id>.
	1- Import the data in the  XML as an OrbeonFormInstance <formObject>."
	| formObject domainObject oop  |

	forms at: (app,'.',form,'.',id) put: xmlString. 
	"create an OrbeonFormInstance -Form Administrator-"
	[formObject := OrbeonHandler default importDataOfFormId: id form: form app: app] on: Error 
		do: [:ex| ^OrbeonPostResult exception: ex].

	formObject ifNil: [^OrbeonPostResult exception: (FormIdNotExistException signal: 'Form [', form, '] of app [', app, '] with id [', id,'] not found')].

	^OrbeonPostResult result: formObject! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 08/27/2015 07:22'!
registerXML: xmlString app: app form: form id: id language: lan valid: valid
	"The receiver register a XML <xmlString> of the OrbeonApplication named <app> of the OrbeonFormDefinition named <form> with an Orbeon database ID <id>.
	1- Import the data in the  XML as an OrbeonFormInstance <formObject>.
	2- Get the Domain Object with the oop in the form.
	3- Associate the Domain Object <domainObject> with the OrbeonFormInstance <formObject>"
	| formObject domainObject oop assignOop assignment |

	formsHistory add: (Array with: app with: form with: id with: valid).
	forms at: (app,'.',form,'.',id) put: xmlString. 
	"create or get the OrbeonFormInstance and the FieldValuedHolder is created or updated inside this method"
	[formObject := OrbeonHandler default importDataOfFormId: id form: form app: app] on: Error 
		do: [:ex | ^OrbeonPostResult exception: ex].

	formObject ifNil: [^OrbeonPostResult exception: (FormIdNotExistException signal: 'Form [', form, '] of app [', app, '] with id [', id,'] not found')].

	oop := formObject valueAt: 'oop'. "get the oop of the <anOrbeonFormTransition>"
	assignOop := formObject valueAt: 'assignmentOop'. 
	formObject isValid: valid.
	"get the Domain Object with -oop- in the form"
	[domainObject := Object _objectForOop: (Integer fromString: oop).
	assignment := Object _objectForOop: (Integer fromString: assignOop).] on: Error
		do: [:ex | ^OrbeonPostResult exception: ex].

	domainObject orbeonFormInstance: formObject. "domain object <anOrbeonFormTransition> associated with the Form <formObject>"
	formObject assignment: assignment. "set the assignment where the form was edited"
	domainObject processDefinition updateFieldsOfForm: formObject. "the indexes of the OrbeonFormProcessDefinition are updated here"

	^OrbeonPostResult result: domainObject! !

!OrbeonFormPostRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 09/05/2014 05:45'!
requestCache

   "Return the value of the instance variable 'requestCache'."
   ^requestCache! !

!OrbeonFormPostRegistry methodsFor: 'Updating' stamp: 'BrunoBB 09/05/2014 05:45'!
requestCache: newValue

   "Modify the value of the instance variable 'requestCache'."
   requestCache := newValue! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/30/2014 19:24'!
reset

	forms := Dictionary new! !

!OrbeonFormPostRegistry methodsFor: 'other' stamp: 'BrunoBB 06/30/2014 19:26'!
resetHistory

	formsHistory := OrderedCollection new! !

Object subclass: #OrbeonPostResult
	instanceVariableNames: 'objectResult exception'
	classVariableNames: 'PostExceptions'
	poolDictionaries: ''
	category: 'OrbeonRestServices'!

!OrbeonPostResult class methodsFor: 'other' stamp: 'BrunoBB 07/15/2015 14:58'!
exception: anException

"	PostExceptions add: anException."

	^super new initialize
		exception: anException;
		yourself! !

!OrbeonPostResult class methodsFor: 'other' stamp: 'BrunoBB 07/15/2015 14:46'!
postExceptions

	PostExceptions ifNil: [PostExceptions := OrderedCollection new].

	^PostExceptions! !

!OrbeonPostResult class methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 07:05'!
result: anObject

	^super new initialize
		objectResult: anObject;
		yourself! !

!OrbeonPostResult methodsFor: 'Accessing' stamp: 'BrunoBB 03/07/2015 07:01'!
exception

   "Return the value of the instance variable 'exception'."
   ^exception! !

!OrbeonPostResult methodsFor: 'Updating' stamp: 'BrunoBB 03/07/2015 07:01'!
exception: newValue

   "Modify the value of the instance variable 'exception'."
   exception := newValue! !

!OrbeonPostResult methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 07:03'!
hasException

	^exception notNil! !

!OrbeonPostResult methodsFor: 'other' stamp: 'BrunoBB 03/07/2015 07:03'!
isOk

	^objectResult notNil! !

!OrbeonPostResult methodsFor: 'Accessing' stamp: 'BrunoBB 03/07/2015 07:01'!
objectResult

   "Return the value of the instance variable 'objectResult'."
   ^objectResult! !

!OrbeonPostResult methodsFor: 'Updating' stamp: 'BrunoBB 03/07/2015 07:01'!
objectResult: newValue

   "Modify the value of the instance variable 'objectResult'."
   objectResult := newValue! !

Object subclass: #OrbeonTempServiceRegistry
	instanceVariableNames: 'tokens failedTokens results'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OrbeonRestServices'!

!OrbeonTempServiceRegistry class methodsFor: 'other' stamp: 'BrunoBB 06/10/2014 17:43'!
default

	Default ifNil: [ Default := super new initialize].

	^Default! !

!OrbeonTempServiceRegistry class methodsFor: 'other' stamp: 'BrunoBB 12/31/2014 15:10'!
default: anObject

	Default := anObject.

	^Default! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 11/08/2014 09:40'!
addFailedToken: aString

	^failedTokens add: aString! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 11/22/2014 11:10'!
createEntryToOrbeonFor: anOrbeonFormTransition for: anOrbeonFormUser
	| temporaryUUID |

	"generate an UUID in <formId>"
	anOrbeonFormTransition generateFormId. 

	temporaryUUID := UUID new asString.
	" here we register the entry that is called from Orbeon to validate the url link"
	self register: temporaryUUID object: anOrbeonFormTransition for: anOrbeonFormUser.

	^temporaryUUID! !

!OrbeonTempServiceRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 06/11/2014 18:19'!
failedTokens

   "Return the value of the instance variable 'failedTokens'."
   ^failedTokens! !

!OrbeonTempServiceRegistry methodsFor: 'Updating' stamp: 'BrunoBB 06/11/2014 18:19'!
failedTokens: newValue

   "Modify the value of the instance variable 'failedTokens'."
   failedTokens := newValue! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 06/13/2015 17:55'!
generateXMLFor: anObject for: anOrbeonFormUser
	| result |

	result := '<result>
		<username>', anOrbeonFormUser username,'</username>
		<rol>', anOrbeonFormUser roleName,'</rol>', String lf.

	anObject serviceIds keysAndValuesDo: [:key :value | | conValue |
		conValue := value ifNil: ['nil'] ifNotNil: [value].
		result := result, '<', key, '>', conValue,'</', key, '>',  String lf. ].

	anObject previousFieldValues keysAndValuesDo: [:key :value | | conValue |
		conValue := value ifNil: ['nil'] ifNotNil: [value].
		result := result, '<', key, '>', conValue,'</', key, '>',  String lf. ].	

	"results add: (result, '</result>', anObject asOop printString)."
	^result, '</result>'! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 02/04/2015 15:29'!
getSecureValueForToken: uuidToken
	| result |

	(tokens includesKey: uuidToken) 
	ifTrue: [result := tokens at: uuidToken.
"				failedTokens add: (Array with: 'ok' with: uuidToken). "
				tokens removeKey: uuidToken ifAbsent: [].
	"			results add: (Array with: 'answer' with: result). "
				^result].

	failedTokens add: (Array with: 'failed' with: uuidToken).

	^nil! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 12/31/2014 15:07'!
initialize

	super initialize.

	tokens := Dictionary new.

	failedTokens := OrderedCollection new.
	results := OrderedCollection new.! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 11/08/2014 09:15'!
register: tempUuid object: anObject for: anOrbeonFormUser

	^tokens at: tempUuid put: (self generateXMLFor: anObject for: anOrbeonFormUser)""! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 06/10/2014 06:47'!
register: token value: anObject

	^tokens at: token put: anObject ""! !

!OrbeonTempServiceRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 12/31/2014 15:07'!
results

   "Return the value of the instance variable 'results'."
   ^results! !

!OrbeonTempServiceRegistry methodsFor: 'Updating' stamp: 'BrunoBB 12/31/2014 15:07'!
results: newValue

   "Modify the value of the instance variable 'results'."
   results := newValue! !

!OrbeonTempServiceRegistry methodsFor: 'Accessing' stamp: 'BrunoBB 06/10/2014 17:43'!
tokens

   "Return the value of the instance variable 'tokens'."
   ^tokens! !

!OrbeonTempServiceRegistry methodsFor: 'Updating' stamp: 'BrunoBB 06/10/2014 17:43'!
tokens: newValue

   "Modify the value of the instance variable 'tokens'."
   tokens := newValue! !

!OrbeonTempServiceRegistry methodsFor: 'other' stamp: 'BrunoBB 09/16/2014 17:26'!
unregister: token

	^tokens removeKey: token ifAbsent: []! !

!WAEmbeddedAssignmentManager methodsFor: '*orbeonRestServices' stamp: 'BrunoBB 11/08/2014 09:22'!
linkToOrbeonFormFor: anOrbeonFormTransition
	"The receiver gives the control to Orbeon Java application."
	| uuid |

	uuid  := OrbeonTempServiceRegistry default 
					createEntryToOrbeonFor: anOrbeonFormTransition 
					for: self session user.

	orbeonFrame := self getUrlFor: anOrbeonFormTransition with: uuid.! !
WAOrbeonServiceHandler initialize!
